!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2010.  Los Alamos National Security, LLC. This material was    !
! produced under U.S. Government contract DE-AC52-06NA25396 for Los Alamos !
! National Laboratory (LANL), which is operated by Los Alamos National     !
! Security, LLC for the U.S. Department of Energy. The U.S. Government has !
! rights to use, reproduce, and distribute this software.  NEITHER THE     !
! GOVERNMENT NOR LOS ALAMOS NATIONAL SECURITY, LLC MAKES ANY WARRANTY,     !
! EXPRESS OR IMPLIED, OR ASSUMES ANY LIABILITY FOR THE USE OF THIS         !
! SOFTWARE.  If software is modified to produce derivative works, such     !
! modified software should be clearly marked, so as not to confuse it      !
! with the version available from LANL.                                    !
!                                                                          !
! Additionally, this program is free software; you can redistribute it     !
! and/or modify it under the terms of the GNU General Public License as    !
! published by the Free Software Foundation; version 2.0 of the License.   !
! Accordingly, this program is distributed in the hope that it will be     !
! useful, but WITHOUT ANY WARRANTY; without even the implied warranty of   !
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General !
! Public License for more details.                                         !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

SUBROUTINE DEALLOCATEALL

  USE SETUPARRAY
  USE GSPARRAY
  USE PPOTARRAY
  USE PBCARRAY
  USE NEBLISTARRAY
  USE MDARRAY
  USE CONSTANTS_MOD
  USE SPINARRAY

  IMPLICIT NONE

  DEALLOCATE(CR, BTYPE, HR0, HES, HEP, ATOCC, H, &
       ELE, ELE1, ELE2, BASIS, ATELE, MASS, HUBBARDU)

  IF (SPINON .EQ. 0) THEN
     DEALLOCATE(BO, BOZERO)
  ELSEIF (SPINON .EQ. 1) THEN
     DEALLOCATE(RHOUP, RHODOWN, HUP, HDOWN, DELTASPIN, OLDDELTASPIN, &
          WSS, WSP, WPP, RHOUPZERO, RHODOWNZERO)
  ENDIF

  DEALLOCATE(GSPR0, GSPRC, GSPR1, GSPRCUT, GSPN, GSPNC, B)
  DEALLOCATE(PPELE1, PPELE2, PPRK, PPAK, VDWC)
  DEALLOCATE(F, FPP, FTOT, PBCUNWRAP)

  DEALLOCATE(NEBTB, NEBPP)
  IF (ELECTRO .EQ. 1) THEN
     DEALLOCATE(NEBCOUL)
  ENDIF
  

  RETURN

END SUBROUTINE DEALLOCATEALL
