!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2010.  Los Alamos National Security, LLC. This material was    !
! produced under U.S. Government contract DE-AC52-06NA25396 for Los Alamos !
! National Laboratory (LANL), which is operated by Los Alamos National     !
! Security, LLC for the U.S. Department of Energy. The U.S. Government has !
! rights to use, reproduce, and distribute this software.  NEITHER THE     !
! GOVERNMENT NOR LOS ALAMOS NATIONAL SECURITY, LLC MAKES ANY WARRANTY,     !
! EXPRESS OR IMPLIED, OR ASSUMES ANY LIABILITY FOR THE USE OF THIS         !
! SOFTWARE.  If software is modified to produce derivative works, such     !
! modified software should be clearly marked, so as not to confuse it      !
! with the version available from LANL.                                    !
!                                                                          !
! Additionally, this program is free software; you can redistribute it     !
! and/or modify it under the terms of the GNU General Public License as    !
! published by the Free Software Foundation; version 2.0 of the License.   !
! Accordingly, this program is distributed in the hope that it will be     !
! useful, but WITHOUT ANY WARRANTY; without even the implied warranty of   !
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General !
! Public License for more details.                                         !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

SUBROUTINE GETDELTASPIN

  USE CONSTANTS_MOD
  USE SETUPARRAY
  USE SPINARRAY
  USE MYPRECISION

  IMPLICIT NONE

  INTEGER :: I, J, K, MYINDEX, DINDEX

  MYINDEX = 0
  DINDEX = 0

!  deltaspin = number of spin ups - number of spin downs

  DO I = 1, NATS

     DO K = 1, NOELEM

        IF (ATELE(I) .EQ. ELE(K)) THEN

           IF (BASIS(K) .EQ. "ss") THEN

              MYINDEX = MYINDEX + 1
              DINDEX = DINDEX + 1
              
              DELTASPIN(DINDEX) = RHOUP(MYINDEX, MYINDEX) - &
                   RHODOWN(MYINDEX, MYINDEX)
              
           ELSEIF (BASIS(K) .EQ. "sp") THEN

              MYINDEX = MYINDEX + 1
              DINDEX = DINDEX + 1

              DELTASPIN(DINDEX) = RHOUP(MYINDEX, MYINDEX) - &
                   RHODOWN(MYINDEX, MYINDEX)
              
              DINDEX = DINDEX + 1

              DELTASPIN(DINDEX) = ZERO

              DO J = 1, 3

                 MYINDEX = MYINDEX + 1

                 DELTASPIN(DINDEX) = DELTASPIN(DINDEX) + &
                      RHOUP(MYINDEX, MYINDEX) - RHODOWN(MYINDEX, MYINDEX)

              ENDDO

           ENDIF

        ENDIF

     ENDDO
  ENDDO
  
  RETURN

END SUBROUTINE GETDELTASPIN
